package com.clx.performance.service.impl;

import com.clx.performance.dao.OrderGoodsLogDao;
import com.clx.performance.model.OrderGoodsLog;
import com.clx.performance.service.OrderGoodsLogService;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 * @author kavin
 * Date 2023-10-26
 * Time 11:27
 */
@Service
@Slf4j
@AllArgsConstructor
public class OrderGoodsLogServiceImpl implements OrderGoodsLogService {

    OrderGoodsLogDao orderGoodsLogDao;

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void saveLog(String orderGoodsNo, Long userNo, String userName, String type, String remark) {
        OrderGoodsLog log = OrderGoodsLog.builder().orderGoodsNo(orderGoodsNo).createBy(userNo).createName(userName).type(type).remark(remark).build();
        orderGoodsLogDao.saveEntity(log);

    }
}
